<?php add_action('template_redirect', 'booked_fea_ajax_actions');
function booked_fea_ajax_actions() {

	// Cancel Appointment
	if (current_user_can('edit_booked_appointments') && isset($_POST['action']) && $_POST['action'] == 'delete_appt' && isset($_POST['appt_id']) && isset($_POST['appt_id']))
	{

		$time_format = get_option('time_format');
		$date_format = get_option('date_format');

		$appt_id = $_POST['appt_id'];
		$appt = get_post($appt_id);
		$user_id = $appt->post_author;
		$timestamp = get_post_meta($appt_id,'_appointment_timestamp',true);
		$cf_meta_value = get_post_meta($appt_id,'_cf_meta_value',true);

		$timeslot = get_post_meta($appt_id,'_appointment_timeslot',true);
		$timeslots = explode('-',$timeslot);

		if ($timeslots[0] == '0000' && $timeslots[1] == '2400'):
			$timeslotText = __('All day','booked-frontend-agents');
		else :
			$timeslotText = date_i18n($time_format,$timestamp);
		endif;
		
		$appointment_calendar_id = get_the_terms( $appt_id,'booked_custom_calendars' );
		if (!empty($appointment_calendar_id)):
			foreach($appointment_calendar_id as $calendar):
				$calendar_id = $calendar->term_id;
				break;
			endforeach;
		else:
			$calendar_id = false;
		endif;
		
		if (!empty($calendar_id)): $calendar_term = get_term_by('id',$calendar_id,'booked_custom_calendars'); $calendar_name = $calendar_term->name; else: $calendar_name = false; endif;

		// Send an email to the user?
		$email_content = get_option('booked_cancellation_email_content');
		$email_subject = get_option('booked_cancellation_email_subject');
		if ($email_content && $email_subject):
		
			$guest_name = get_post_meta($appt_id, '_appointment_guest_name',true);
			$guest_email = get_post_meta($appt_id, '_appointment_guest_email',true);
		
			if (!$guest_name):
				$user_name = booked_get_name($user_id);
				$user_data = get_userdata( $user_id );
				$email = $user_data->user_email;
			else:
				$user_name = $guest_name;
				$email = $guest_email;
			endif;
			
			$tokens = array('%name%','%date%','%time%','%customfields%','%calendar%','%email%');
			$replacements = array($user_name,date_i18n($date_format,$timestamp),$timeslotText,$cf_meta_value,$calendar_name,$email);
			$email_content = htmlentities(str_replace($tokens,$replacements,$email_content), ENT_QUOTES | ENT_IGNORE, "UTF-8");
			$email_content = html_entity_decode($email_content, ENT_QUOTES | ENT_IGNORE, "UTF-8");
			$email_subject = str_replace($tokens,$replacements,$email_subject);
			booked_mailer( $email, $email_subject, $email_content );
		endif;

		wp_delete_post($appt_id,true);
		exit;
	}
	
	// Approve Appointment
	if (current_user_can('edit_booked_appointments') && isset($_POST['action']) && $_POST['action'] == 'approve_appt' && isset($_POST['appt_id']) && isset($_POST['appt_id']))
	{
		$appt_id = $_POST['appt_id'];
		$this_appt = array(
			'ID'          => $appt_id,
		    'post_status' => 'publish'
		);

		$time_format = get_option('time_format');
		$date_format = get_option('date_format');

		$appt = get_post($appt_id);
		$user_id = $appt->post_author;
		$timestamp = get_post_meta($appt_id,'_appointment_timestamp',true);
		$cf_meta_value = get_post_meta($appt_id,'_cf_meta_value',true);

		$timeslot = get_post_meta($appt_id,'_appointment_timeslot',true);
		$timeslots = explode('-',$timeslot);

		if ($timeslots[0] == '0000' && $timeslots[1] == '2400'):
			$timeslotText = __('All day','booked-frontend-agents');
		else :
			$timeslotText = date_i18n($time_format,$timestamp);
		endif;
		
		$appointment_calendar_id = get_the_terms( $appt_id,'booked_custom_calendars' );
		if (!empty($appointment_calendar_id)):
			foreach($appointment_calendar_id as $calendar):
				$calendar_id = $calendar->term_id;
				break;
			endforeach;
		else:
			$calendar_id = false;
		endif;
		
		if (!empty($calendar_id)): $calendar_term = get_term_by('id',$calendar_id,'booked_custom_calendars'); $calendar_name = $calendar_term->name; else: $calendar_name = false; endif;

		// Send an email to the user?
		$email_content = get_option('booked_approval_email_content');
		$email_subject = get_option('booked_approval_email_subject');
		if ($email_content && $email_subject):
		
			$guest_name = get_post_meta($appt_id, '_appointment_guest_name',true);
			$guest_email = get_post_meta($appt_id, '_appointment_guest_email',true);
			
			if (!$guest_name):
				$user_name = booked_get_name($user_id);
				$user_data = get_userdata( $user_id );
				$email = $user_data->user_email;
			else:
				$user_name = $guest_name;
				$email = $guest_email;
			endif;
			
			$tokens = array('%name%','%date%','%time%','%customfields%','%calendar%','%email%');
			$replacements = array($user_name,date_i18n($date_format,$timestamp),$timeslotText,$cf_meta_value,$calendar_name,$email);
			$email_content = htmlentities(str_replace($tokens,$replacements,$email_content), ENT_QUOTES | ENT_IGNORE, "UTF-8");
			$email_content = html_entity_decode($email_content, ENT_QUOTES | ENT_IGNORE, "UTF-8");
			$email_subject = str_replace($tokens,$replacements,$email_subject);
			booked_mailer( $email, $email_subject, $email_content );
		endif;

		wp_update_post( $this_appt );
		exit;
	}
	
}