<?php add_action('template_redirect', 'booked_fea_ajax_loaders');
function booked_fea_ajax_loaders() {

	if (current_user_can('edit_booked_appointments') && isset($_POST['load']) && $_POST['load'] == 'user_info_modal' && isset($_POST['user_id']))
	{
		
		echo '<div class="booked-scrollable">';
			echo '<p class="booked-title-bar"><small>' . __('Appointment Information','booked-frontend-agents') . '</small></p>';
	
			if (!$_POST['user_id'] && isset($_POST['appt_id'])):
			
				$guest_name = get_post_meta($_POST['appt_id'], '_appointment_guest_name',true);
				$guest_email = get_post_meta($_POST['appt_id'], '_appointment_guest_email',true);
			
				echo '<p class="fea-modal-title">'.__('Contact Information','booked-frontend-agents').'</p>';
				echo '<p><strong class="booked-left-title">'.__('Name','booked-frontend-agents').':</strong> '.$guest_name.'<br>';
				if ($guest_email) : echo '<strong class="booked-left-title">'.__('Email','booked-frontend-agents').':</strong> <a href="mailto:'.$guest_email.'">'.$guest_email.'</a>'; endif;
				echo '</p>';
				
			else :
	
				// Customer Information
				$user_info = get_userdata($_POST['user_id']);
				$display_name = booked_get_name($_POST['user_id']);
				$email = $user_info->user_email;
				$phone = get_user_meta($_POST['user_id'], 'booked_phone', true);
		
				echo '<p class="fea-modal-title">'.__('Contact Information','booked-frontend-agents').'</p>';
				echo '<p><strong class="booked-left-title">'.__('Name','booked-frontend-agents').':</strong> '.$display_name.'<br>';
				if ($email) : echo '<strong class="booked-left-title">'.__('Email','booked-frontend-agents').':</strong> <a href="mailto:'.$email.'">'.$email.'</a><br>'; endif;
				if ($phone) : echo '<strong class="booked-left-title">'.__('Phone','booked-frontend-agents').':</strong> <a href="tel:'.preg_replace('/[^0-9+]/', '', $phone).'">'.$phone.'</a>'; endif;
				echo '</p>';
	
			endif;
	
			// Appointment Information
			if (isset($_POST['appt_id'])):
	
				$time_format = get_option('time_format');
				$date_format = get_option('date_format');
				$appt_id = $_POST['appt_id'];
	
				$timestamp = get_post_meta($appt_id, '_appointment_timestamp',true);
				$timeslot = get_post_meta($appt_id, '_appointment_timeslot',true);
				$cf_meta_value = get_post_meta($appt_id, '_cf_meta_value',true);
	
				$date_display = date_i18n($date_format,$timestamp);
				$day_name = date_i18n('l',$timestamp);
	
				$timeslots = explode('-',$timeslot);
				$time_start = date($time_format,strtotime($timeslots[0]));
				$time_end = date($time_format,strtotime($timeslots[1]));
	
				if ($timeslots[0] == '0000' && $timeslots[1] == '2400'):
					$timeslotText = 'All day';
				else :
					$timeslotText = $time_start.' '.__('to','booked-frontend-agents').' '.$time_end;
				endif;
	
				echo '<p class="fea-modal-title fea-bordered">'.__('Appointment Information','booked-frontend-agents').'</p>';
				do_action('booked_before_appointment_information_admin');
				echo '<p><strong class="booked-left-title">'.__('Date','booked-frontend-agents').':</strong> '.$day_name.', '.$date_display.'<br>';
				echo '<strong class="booked-left-title">'.__('Time','booked-frontend-agents').':</strong> '.$timeslotText.'</p>';
				echo ($cf_meta_value ? '<div class="cf-meta-values">'.$cf_meta_value.'</div>' : '');
				do_action('booked_after_appointment_information_admin');
	
			endif;
	
			// Close button
			echo '<a href="#" class="close"><i class="fa fa-remove"></i></a>';
		echo '</div>';
		
		exit;
		
	}
	
}